Index: issm/trunk-jpl/src/c/classes/Materials/Matseaice.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Materials/Matseaice.cpp	(revision 18492)
+++ issm/trunk-jpl/src/c/classes/Materials/Matseaice.cpp	(revision 18492)
@@ -0,0 +1,136 @@
+/*!\file Matseaice.c
+ * \brief: implementation of the Matseaice object
+ */
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./Matseaice.h"
+#include "./Materials.h"
+#include "../Inputs/Input.h"
+#include "../Inputs/Inputs.h"
+#include "../Inputs/TriaInput.h"
+#include "../Inputs/PentaInput.h"
+#include "../Inputs/ControlInput.h"
+#include "../Elements/Element.h"
+#include "../Elements/Tria.h"
+#include "../Elements/Penta.h"
+#include "../Params/Parameters.h"
+#include "../Vertex.h"
+#include "../Hook.h"
+#include "../Node.h"
+#include "../IoModel.h"
+#include "../../shared/shared.h"
+
+/*Matseaice constructors and destructor*/
+Matseaice::Matseaice(){/*{{{*/
+	this->helement=NULL;
+	this->element=NULL;
+	return;
+}
+/*}}}*/
+Matseaice::Matseaice(int matice_mid,int index, IoModel* iomodel){/*{{{*/
+
+	/*Intermediaries:*/
+	int    matice_eid;
+
+	/*Initialize id*/
+	this->mid=matice_mid;
+
+	/*Hooks: */
+	matice_eid=index+1;
+	this->helement=new Hook(&matice_eid,1);
+	this->element=NULL;
+
+	return;
+}
+/*}}}*/
+Matseaice::~Matseaice(){/*{{{*/
+	delete helement;
+	return;
+}
+/*}}}*/
+
+/*Object virtual functions definitions:*/
+void Matseaice::Echo(void){/*{{{*/
+
+	_printf_("Matseaice:\n");
+	_printf_("   mid: " << mid << "\n");
+	_printf_("   element:\n");
+	helement->Echo();
+}
+/*}}}*/
+void Matseaice::DeepEcho(void){/*{{{*/
+
+	_printf_("Matseaice:\n");
+	_printf_("   mid: " << mid << "\n");
+	_printf_("   element:\n");
+	helement->Echo();
+}		
+/*}}}*/
+int  Matseaice::Id(void){ return mid; }/*{{{*/
+/*}}}*/
+int Matseaice::ObjectEnum(void){/*{{{*/
+
+	return MatseaiceEnum;
+
+}
+/*}}}*/
+Object* Matseaice::copy() {/*{{{*/
+
+	/*Output*/
+	Matseaice* matice=NULL;
+
+	/*Initialize output*/
+	matice=new Matseaice();
+
+	/*copy fields: */
+	matice->mid=this->mid;
+	matice->helement=(Hook*)this->helement->copy();
+	matice->element =(Element*)this->helement->delivers();
+
+	return matice;
+}
+/*}}}*/
+Material* Matseaice::copy2(Element* element_in) {/*{{{*/
+
+	/*Output*/
+	Matseaice* matice=NULL;
+
+	/*Initialize output*/
+	matice=new Matseaice();
+
+	/*copy fields: */
+	matice->mid=this->mid;
+	matice->helement=(Hook*)this->helement->copy();
+	matice->element =element_in;
+
+	return matice;
+}
+/*}}}*/
+
+/*Matseaice management*/
+void  Matseaice::Configure(Elements* elementsin){/*{{{*/
+
+	/*Take care of hooking up all objects for this element, ie links the objects in the hooks to their respective 
+	 * datasets, using internal ids and offsets hidden in hooks: */
+	helement->configure((DataSet*)elementsin);
+	this->element  = (Element*)helement->delivers();
+}
+/*}}}*/
+void  Matseaice::SetCurrentConfiguration(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){/*{{{*/
+
+}
+/*}}}*/
+void  Matseaice::ResetHooks(){/*{{{*/
+
+	this->element=NULL;
+
+	/*Get Element type*/
+	this->helement->reset();
+
+}
+/*}}}*/
Index: issm/trunk-jpl/src/c/classes/Materials/Matseaice.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Materials/Matseaice.h	(revision 18492)
+++ issm/trunk-jpl/src/c/classes/Materials/Matseaice.h	(revision 18492)
@@ -0,0 +1,75 @@
+/*!\file Matseaice.h
+ * \brief: header file for matice object
+ */
+
+#ifndef MATSEAICE_H_
+#define MATSEAICE_H_
+
+/*Headers:*/
+/*{{{*/
+#include "./Material.h"
+#include "../Hook.h"
+class IoModel;
+class Elements;
+class Element;
+class Loads;
+class Nodes;
+class Vertices;
+class Materials;
+class Parameters;
+/*}}}*/
+
+class Matseaice: public Material{
+
+	private: 
+		int      mid;
+		Hook    *helement;
+		Element *element;
+
+	public:
+		/*Matseaice constructors, destructors: {{{*/
+		Matseaice();
+		Matseaice(int mid,int i, IoModel* iomodel);
+		~Matseaice();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		void  Echo();
+		void  DeepEcho();
+		int   Id(); 
+		int   ObjectEnum();
+		Object* copy();
+		/*}}}*/
+		/*Update virtual funictions definitions: {{{*/
+		void  InputUpdateFromVector(IssmDouble* vector, int name, int type){_error_("not implemented");};
+		void  InputUpdateFromMatrixDakota(IssmDouble* matrix, int nrow, int ncols, int name, int type){_error_("not implemented");};
+		void  InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type){_error_("not implemented");};
+		void  InputUpdateFromConstant(IssmDouble constant, int name){_error_("not implemented");};
+		void  InputUpdateFromConstant(int constant, int name){_error_("not implemented");};
+		void  InputUpdateFromConstant(bool constant, int name){_error_("not implemented");};
+		void  InputUpdateFromIoModel(int index, IoModel* iomodel){_error_("not implemented");};
+		/*}}}*/
+		/*Material virtual functions resolution: {{{*/
+		void   Configure(Elements* elements);
+		Material*  copy2(Element* element);
+		void       SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters);
+		void       GetViscosity(IssmDouble* pviscosity, IssmDouble eps_eff){_error_("not supported for this material");};
+		void       GetViscosity_B(IssmDouble* pviscosity, IssmDouble eps_eff){_error_("not supported for this material");};
+		void       GetViscosity_D(IssmDouble* pviscosity, IssmDouble eps_eff){_error_("not supported for this material");};
+		void       GetViscosityBar(IssmDouble* pviscosity, IssmDouble eps_eff){_error_("not supported for this material");};
+		void       GetViscosityComplement(IssmDouble* pviscosity_complement, IssmDouble* pepsilon){_error_("not supported for this material");};
+		void       GetViscosityDComplement(IssmDouble*, IssmDouble*){_error_("not supported for this material");};
+		void       GetViscosityDerivativeEpsSquare(IssmDouble* pmu_prime, IssmDouble* pepsilon){_error_("not supported for this material");};
+		void       GetViscosity2dDerivativeEpsSquare(IssmDouble* pmu_prime, IssmDouble* pepsilon){_error_("not supported for this material");};
+		IssmDouble GetA(){_error_("not supported for this material");};
+		IssmDouble GetAbar(){_error_("not supported for this material");};
+		IssmDouble GetB(){_error_("not supported for this material");};
+		IssmDouble GetBbar(){_error_("not supported for this material");};
+		IssmDouble GetD(){_error_("not supported for this material");};
+		IssmDouble GetDbar(){_error_("not supported for this material");};
+		IssmDouble GetN(){_error_("not supported for this material");};
+		bool       IsDamage(){_error_("not supported for this material");};
+		void       ResetHooks();
+		/*}}}*/
+};
+
+#endif  /* _MATICE_H_ */
Index: issm/trunk-jpl/src/c/classes/Vertex.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Vertex.cpp	(revision 18491)
+++ issm/trunk-jpl/src/c/classes/Vertex.cpp	(revision 18492)
@@ -32,15 +32,19 @@
 	this->domaintype     = iomodel->domaintype;
 
-	_assert_(iomodel->Data(BaseEnum) && iomodel->Data(ThicknessEnum) && iomodel->numbernodetoelementconnectivity);
 	switch(iomodel->domaintype){
 		case Domain3DEnum:
-		case Domain2DhorizontalEnum:
+			_assert_(iomodel->Data(BaseEnum) && iomodel->Data(ThicknessEnum));
 			this->sigma = (iomodel->Data(MeshZEnum)[i]-iomodel->Data(BaseEnum)[i])/(iomodel->Data(ThicknessEnum)[i]);
 			break;
+		case Domain2DhorizontalEnum:
+			this->sigma = 0.;
+			break;
 		case Domain2DverticalEnum:
+			_assert_(iomodel->Data(BaseEnum) && iomodel->Data(ThicknessEnum));
 			this->sigma = (iomodel->Data(MeshYEnum)[i]-iomodel->Data(BaseEnum)[i])/(iomodel->Data(ThicknessEnum)[i]);
 			break;
 	}
 
+	_assert_(iomodel->numbernodetoelementconnectivity);
 	this->connectivity = iomodel->numbernodetoelementconnectivity[i];
 
Index: issm/trunk-jpl/src/c/classes/classes.h
===================================================================
--- issm/trunk-jpl/src/c/classes/classes.h	(revision 18491)
+++ issm/trunk-jpl/src/c/classes/classes.h	(revision 18492)
@@ -78,4 +78,5 @@
 #include "./Materials/Material.h"
 #include "./Materials/Matice.h"
+#include "./Materials/Matseaice.h"
 #include "./Materials/Matpar.h"
 
Index: issm/trunk-jpl/src/c/cores/AnalysisConfiguration.cpp
===================================================================
--- issm/trunk-jpl/src/c/cores/AnalysisConfiguration.cpp	(revision 18491)
+++ issm/trunk-jpl/src/c/cores/AnalysisConfiguration.cpp	(revision 18492)
@@ -148,4 +148,10 @@
 			break;
 
+		case SeaiceSolutionEnum:
+			numanalyses=1;
+			analyses=xNew<int>(numanalyses);
+			analyses[0]=SeaiceAnalysisEnum;
+			break;
+
 		default:
 			_error_("solution type: " << EnumToStringx(solutiontype) << " not supported yet!");
Index: issm/trunk-jpl/src/c/cores/CorePointerFromSolutionEnum.cpp
===================================================================
--- issm/trunk-jpl/src/c/cores/CorePointerFromSolutionEnum.cpp	(revision 18491)
+++ issm/trunk-jpl/src/c/cores/CorePointerFromSolutionEnum.cpp	(revision 18492)
@@ -69,4 +69,7 @@
 			solutioncore=&damage_core;
 			break;
+		case SeaiceSolutionEnum:
+			solutioncore=&seaice_core;
+			break;
 		default:
 			_error_("solution type: " << EnumToStringx(solutiontype) << " not supported yet!");
Index: issm/trunk-jpl/src/c/cores/cores.h
===================================================================
--- issm/trunk-jpl/src/c/cores/cores.h	(revision 18491)
+++ issm/trunk-jpl/src/c/cores/cores.h	(revision 18492)
@@ -45,4 +45,5 @@
 void gia_core(FemModel* femmodel);
 void damage_core(FemModel* femmodel);
+void seaice_core(FemModel* femmodel);
 IssmDouble objectivefunction(IssmDouble search_scalar,FemModel* femmodel);
 
Index: issm/trunk-jpl/src/c/cores/seaice_core.cpp
===================================================================
--- issm/trunk-jpl/src/c/cores/seaice_core.cpp	(revision 18492)
+++ issm/trunk-jpl/src/c/cores/seaice_core.cpp	(revision 18492)
@@ -0,0 +1,30 @@
+/*!\file: seaice_core.cpp
+ * \brief: core of the seaice solution 
+ */ 
+
+#include "./cores.h"
+#include "../toolkits/toolkits.h"
+#include "../classes/classes.h"
+#include "../shared/shared.h"
+#include "../modules/modules.h"
+#include "../solutionsequences/solutionsequences.h"
+
+void seaice_core(FemModel* femmodel){
+
+	/*parameters: */
+	bool save_results;
+
+	/*recover parameters: */
+	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
+
+	if(VerboseSolution()) _printf0_("call computational core:\n");
+	femmodel->SetCurrentConfiguration(SeaiceAnalysisEnum);
+	solutionsequence_linear(femmodel);
+
+	if(save_results){
+		if(VerboseSolution()) _printf0_("   saving results\n");
+		int outputs[6] = {VxEnum,VyEnum,VelEnum,SeaiceConcentrationEnum,SeaiceThicknessEnum,MaterialsDamageEnum};
+		femmodel->RequestedOutputsx(&femmodel->results,&outputs[0],6);
+	}
+
+}
Index: issm/trunk-jpl/src/c/modules/Bamgx/Bamgx.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/Bamgx/Bamgx.cpp	(revision 18491)
+++ issm/trunk-jpl/src/c/modules/Bamgx/Bamgx.cpp	(revision 18492)
@@ -200,5 +200,7 @@
 
 		/*clean up*/
+		printf("-------------- file: Bamgx.cpp line: %i\n",__LINE__); 
 		delete &Th;
+		printf("-------------- file: Bamgx.cpp line: %i\n",__LINE__); 
 		//delete &BTh;
 		/*}}}*/
@@ -207,4 +209,5 @@
 	/*No error return*/
 	if (verbosity>1) _printf_("   Exiting Bamg.\n");
+	printf("-------------- file: Bamgx.cpp line: %i\n",__LINE__); 
 	return noerr;
 
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 18491)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateElementsVerticesAndMaterials.cpp	(revision 18492)
@@ -79,4 +79,8 @@
 			}
 			break;
+		case MatseaiceEnum:
+			iomodel->FetchDataToInput(elements,MaterialsDamageEnum);
+			for (i=0;i<iomodel->numberofelements;i++) if(iomodel->my_elements[i]) materials->AddObject(new Matseaice(i+1,i,iomodel));
+			break;
 		default:
 			_error_("Materials "<<EnumToStringx(materials_type)<<" not supported");
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateParameters.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 18491)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 18492)
@@ -43,8 +43,5 @@
 	parameters->AddObject(iomodel->CopyConstantObject(DomainTypeEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(DomainDimensionEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(MeshElementtypeEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(SettingsOutputFrequencyEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(SteadystateReltolEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(SteadystateMaxiterEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(ConstantsYtsEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(TimesteppingStartTimeEnum));
@@ -57,5 +54,4 @@
 	parameters->AddObject(iomodel->CopyConstantObject(DebugProfilingEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(MeshAverageVertexConnectivityEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(ConstantsReferencetemperatureEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(SettingsWaitonlockEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(MeshNumberofelementsEnum));
@@ -63,29 +59,37 @@
 	parameters->AddObject(iomodel->CopyConstantObject(SettingsResultsOnNodesEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(SettingsIoGatherEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(GroundinglineMigrationEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(TransientIsstressbalanceEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(TransientIsmasstransportEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(TransientIsthermalEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(TransientIsgroundinglineEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(TransientIsgiaEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(TransientIslevelsetEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(TransientIsdamageevolutionEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(TransientIshydrologyEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(MaterialsRheologyLawEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(AutodiffIsautodiffEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(QmuIsdakotaEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(InversionIscontrolEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(InversionTypeEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(GiaCrossSectionShapeEnum));
-
-	/*For stress balance only*/
-	parameters->AddObject(iomodel->CopyConstantObject(FlowequationIsFSEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(StressbalanceRiftPenaltyThresholdEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(StressbalanceMaxiterEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(StressbalanceRestolEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(StressbalanceReltolEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(StressbalanceAbstolEnum));
-	if(iomodel->domaintype==Domain3DEnum)
-	 parameters->AddObject(iomodel->CopyConstantObject(MeshNumberoflayersEnum));
+	if(solution_type==SeaiceSolutionEnum){
+	}
+	else{
+		parameters->AddObject(iomodel->CopyConstantObject(MeshElementtypeEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(SteadystateReltolEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(SteadystateMaxiterEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(ConstantsReferencetemperatureEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(GroundinglineMigrationEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(TransientIsstressbalanceEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(TransientIsmasstransportEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(TransientIsthermalEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(TransientIsgroundinglineEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(TransientIsgiaEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(TransientIslevelsetEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(TransientIsdamageevolutionEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(TransientIshydrologyEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(MaterialsRheologyLawEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(GiaCrossSectionShapeEnum));
+
+		/*For stress balance only*/
+		parameters->AddObject(iomodel->CopyConstantObject(FlowequationIsFSEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(StressbalanceRiftPenaltyThresholdEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(StressbalanceMaxiterEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(StressbalanceRestolEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(StressbalanceReltolEnum));
+		parameters->AddObject(iomodel->CopyConstantObject(StressbalanceAbstolEnum));
+		if(iomodel->domaintype==Domain3DEnum)
+		 parameters->AddObject(iomodel->CopyConstantObject(MeshNumberoflayersEnum));
+	}
 
 	/*Surface mass balance parameters*/
@@ -129,4 +133,10 @@
 			/*Nothing to add to parameters*/
 			break;
+		case SeaiceatmEnum:
+			parameters->AddObject(iomodel->CopyConstantObject(SurfaceforcingsRhoAirEnum));
+			parameters->AddObject(iomodel->CopyConstantObject(SurfaceforcingsAirCoefEnum));
+			parameters->AddObject(iomodel->CopyConstantObject(SurfaceforcingsAirLinDragCoefEnum));
+			parameters->AddObject(iomodel->CopyConstantObject(SurfaceforcingsAirQuadDragCoefEnum));
+			break;
 		default:
 			_error_("Surface mass balance model "<<EnumToStringx(smb_model)<<" not supported yet");
@@ -144,4 +154,11 @@
 			parameters->AddObject(iomodel->CopyConstantObject(BasalforcingsDeepwaterElevationEnum));
 			parameters->AddObject(iomodel->CopyConstantObject(BasalforcingsUpperwaterElevationEnum));
+			break;
+		case SeaiceoceanEnum:
+			parameters->AddObject(iomodel->CopyConstantObject(BasalforcingsRhoOceanEnum));
+			parameters->AddObject(iomodel->CopyConstantObject(BasalforcingsOceanCoefEnum));
+			parameters->AddObject(iomodel->CopyConstantObject(BasalforcingsOceanLinDragCoefEnum));
+			parameters->AddObject(iomodel->CopyConstantObject(BasalforcingsOceanQuadDragCoefEnum));
+			parameters->AddObject(iomodel->CopyConstantObject(BasalforcingsOceanTurningAngleEnum));
 			break;
 		default:
Index: issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 18491)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 18492)
@@ -387,4 +387,6 @@
 	GiaSolutionEnum,
 	GiaAnalysisEnum,
+	SeaiceSolutionEnum,
+	SeaiceAnalysisEnum,
 	MeshdeformationSolutionEnum,
 	MeshdeformationAnalysisEnum,
@@ -742,4 +744,37 @@
 	LevelsetfunctionPicardEnum,
 	/*}}}*/
+	/*Sea Ice {{{*/
+	SeaiceatmEnum,
+	SeaiceoceanEnum,
+	SeaiceThicknessEnum,
+	SeaiceConcentrationEnum,
+	SeaiceSpcvxEnum,
+	SeaiceSpcvyEnum,
+	BasalforcingsRhoOceanEnum,
+	BasalforcingsOceanCoefEnum,
+	BasalforcingsOceanLinDragCoefEnum,
+	BasalforcingsOceanQuadDragCoefEnum,
+	BasalforcingsOceanTurningAngleEnum,
+	BasalforcingsOceanSshEnum,
+	BasalforcingsOceanVxEnum,
+	BasalforcingsOceanVyEnum,
+	SurfaceforcingsRhoAirEnum,
+	SurfaceforcingsAirCoefEnum,
+	SurfaceforcingsAirLinDragCoefEnum,
+	SurfaceforcingsAirQuadDragCoefEnum,
+	SurfaceforcingsWindVxEnum,
+	SurfaceforcingsWindVyEnum,
+	MatseaiceEnum,
+	MaterialsPoissonEnum,
+	MaterialsYoungModulusEnum,
+	MaterialsDamageEnum,
+	MaterialsRidgingExponentEnum,
+	MaterialsCohesionEnum,
+	MaterialsInternalFrictionCoefEnum,
+	MaterialsCompressionCoefEnum,
+	MaterialsTractionCoefEnum,
+	VxStarEnum,
+	VyStarEnum,
+	/*}}}*/
 	MaximumNumberOfDefinitionsEnum
 };
Index: issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 18491)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 18492)
@@ -390,4 +390,6 @@
 		case GiaSolutionEnum : return "GiaSolution";
 		case GiaAnalysisEnum : return "GiaAnalysis";
+		case SeaiceSolutionEnum : return "SeaiceSolution";
+		case SeaiceAnalysisEnum : return "SeaiceAnalysis";
 		case MeshdeformationSolutionEnum : return "MeshdeformationSolution";
 		case MeshdeformationAnalysisEnum : return "MeshdeformationAnalysis";
@@ -702,4 +704,35 @@
 		case LevelsetfunctionSlopeYEnum : return "LevelsetfunctionSlopeY";
 		case LevelsetfunctionPicardEnum : return "LevelsetfunctionPicard";
+		case SeaiceatmEnum : return "Seaiceatm";
+		case SeaiceoceanEnum : return "Seaiceocean";
+		case SeaiceThicknessEnum : return "SeaiceThickness";
+		case SeaiceConcentrationEnum : return "SeaiceConcentration";
+		case SeaiceSpcvxEnum : return "SeaiceSpcvx";
+		case SeaiceSpcvyEnum : return "SeaiceSpcvy";
+		case BasalforcingsRhoOceanEnum : return "BasalforcingsRhoOcean";
+		case BasalforcingsOceanCoefEnum : return "BasalforcingsOceanCoef";
+		case BasalforcingsOceanLinDragCoefEnum : return "BasalforcingsOceanLinDragCoef";
+		case BasalforcingsOceanQuadDragCoefEnum : return "BasalforcingsOceanQuadDragCoef";
+		case BasalforcingsOceanTurningAngleEnum : return "BasalforcingsOceanTurningAngle";
+		case BasalforcingsOceanSshEnum : return "BasalforcingsOceanSsh";
+		case BasalforcingsOceanVxEnum : return "BasalforcingsOceanVx";
+		case BasalforcingsOceanVyEnum : return "BasalforcingsOceanVy";
+		case SurfaceforcingsRhoAirEnum : return "SurfaceforcingsRhoAir";
+		case SurfaceforcingsAirCoefEnum : return "SurfaceforcingsAirCoef";
+		case SurfaceforcingsAirLinDragCoefEnum : return "SurfaceforcingsAirLinDragCoef";
+		case SurfaceforcingsAirQuadDragCoefEnum : return "SurfaceforcingsAirQuadDragCoef";
+		case SurfaceforcingsWindVxEnum : return "SurfaceforcingsWindVx";
+		case SurfaceforcingsWindVyEnum : return "SurfaceforcingsWindVy";
+		case MatseaiceEnum : return "Matseaice";
+		case MaterialsPoissonEnum : return "MaterialsPoisson";
+		case MaterialsYoungModulusEnum : return "MaterialsYoungModulus";
+		case MaterialsDamageEnum : return "MaterialsDamage";
+		case MaterialsRidgingExponentEnum : return "MaterialsRidgingExponent";
+		case MaterialsCohesionEnum : return "MaterialsCohesion";
+		case MaterialsInternalFrictionCoefEnum : return "MaterialsInternalFrictionCoef";
+		case MaterialsCompressionCoefEnum : return "MaterialsCompressionCoef";
+		case MaterialsTractionCoefEnum : return "MaterialsTractionCoef";
+		case VxStarEnum : return "VxStar";
+		case VyStarEnum : return "VyStar";
 		case MaximumNumberOfDefinitionsEnum : return "MaximumNumberOfDefinitions";
 		default : return "unknown";
Index: issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 18491)
+++ issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 18492)
@@ -399,4 +399,6 @@
 	      else if (strcmp(name,"GiaSolution")==0) return GiaSolutionEnum;
 	      else if (strcmp(name,"GiaAnalysis")==0) return GiaAnalysisEnum;
+	      else if (strcmp(name,"SeaiceSolution")==0) return SeaiceSolutionEnum;
+	      else if (strcmp(name,"SeaiceAnalysis")==0) return SeaiceAnalysisEnum;
 	      else if (strcmp(name,"MeshdeformationSolution")==0) return MeshdeformationSolutionEnum;
 	      else if (strcmp(name,"MeshdeformationAnalysis")==0) return MeshdeformationAnalysisEnum;
@@ -504,10 +506,10 @@
 	      else if (strcmp(name,"MeltingOffset")==0) return MeltingOffsetEnum;
 	      else if (strcmp(name,"Misfit")==0) return MisfitEnum;
-	      else if (strcmp(name,"Pressure")==0) return PressureEnum;
-	      else if (strcmp(name,"PressurePicard")==0) return PressurePicardEnum;
          else stage=5;
    }
    if(stage==5){
-	      if (strcmp(name,"AndroidFrictionCoefficient")==0) return AndroidFrictionCoefficientEnum;
+	      if (strcmp(name,"Pressure")==0) return PressureEnum;
+	      else if (strcmp(name,"PressurePicard")==0) return PressurePicardEnum;
+	      else if (strcmp(name,"AndroidFrictionCoefficient")==0) return AndroidFrictionCoefficientEnum;
 	      else if (strcmp(name,"ResetPenalties")==0) return ResetPenaltiesEnum;
 	      else if (strcmp(name,"SegmentOnIceShelf")==0) return SegmentOnIceShelfEnum;
@@ -627,10 +629,10 @@
 	      else if (strcmp(name,"SurfaceObservation")==0) return SurfaceObservationEnum;
 	      else if (strcmp(name,"WeightsSurfaceObservation")==0) return WeightsSurfaceObservationEnum;
-	      else if (strcmp(name,"MinVel")==0) return MinVelEnum;
-	      else if (strcmp(name,"MaxVel")==0) return MaxVelEnum;
          else stage=6;
    }
    if(stage==6){
-	      if (strcmp(name,"MinVx")==0) return MinVxEnum;
+	      if (strcmp(name,"MinVel")==0) return MinVelEnum;
+	      else if (strcmp(name,"MaxVel")==0) return MaxVelEnum;
+	      else if (strcmp(name,"MinVx")==0) return MinVxEnum;
 	      else if (strcmp(name,"MaxVx")==0) return MaxVxEnum;
 	      else if (strcmp(name,"MaxAbsVx")==0) return MaxAbsVxEnum;
@@ -717,4 +719,35 @@
 	      else if (strcmp(name,"LevelsetfunctionSlopeY")==0) return LevelsetfunctionSlopeYEnum;
 	      else if (strcmp(name,"LevelsetfunctionPicard")==0) return LevelsetfunctionPicardEnum;
+	      else if (strcmp(name,"Seaiceatm")==0) return SeaiceatmEnum;
+	      else if (strcmp(name,"Seaiceocean")==0) return SeaiceoceanEnum;
+	      else if (strcmp(name,"SeaiceThickness")==0) return SeaiceThicknessEnum;
+	      else if (strcmp(name,"SeaiceConcentration")==0) return SeaiceConcentrationEnum;
+	      else if (strcmp(name,"SeaiceSpcvx")==0) return SeaiceSpcvxEnum;
+	      else if (strcmp(name,"SeaiceSpcvy")==0) return SeaiceSpcvyEnum;
+	      else if (strcmp(name,"BasalforcingsRhoOcean")==0) return BasalforcingsRhoOceanEnum;
+	      else if (strcmp(name,"BasalforcingsOceanCoef")==0) return BasalforcingsOceanCoefEnum;
+	      else if (strcmp(name,"BasalforcingsOceanLinDragCoef")==0) return BasalforcingsOceanLinDragCoefEnum;
+	      else if (strcmp(name,"BasalforcingsOceanQuadDragCoef")==0) return BasalforcingsOceanQuadDragCoefEnum;
+	      else if (strcmp(name,"BasalforcingsOceanTurningAngle")==0) return BasalforcingsOceanTurningAngleEnum;
+	      else if (strcmp(name,"BasalforcingsOceanSsh")==0) return BasalforcingsOceanSshEnum;
+	      else if (strcmp(name,"BasalforcingsOceanVx")==0) return BasalforcingsOceanVxEnum;
+	      else if (strcmp(name,"BasalforcingsOceanVy")==0) return BasalforcingsOceanVyEnum;
+	      else if (strcmp(name,"SurfaceforcingsRhoAir")==0) return SurfaceforcingsRhoAirEnum;
+	      else if (strcmp(name,"SurfaceforcingsAirCoef")==0) return SurfaceforcingsAirCoefEnum;
+	      else if (strcmp(name,"SurfaceforcingsAirLinDragCoef")==0) return SurfaceforcingsAirLinDragCoefEnum;
+	      else if (strcmp(name,"SurfaceforcingsAirQuadDragCoef")==0) return SurfaceforcingsAirQuadDragCoefEnum;
+	      else if (strcmp(name,"SurfaceforcingsWindVx")==0) return SurfaceforcingsWindVxEnum;
+	      else if (strcmp(name,"SurfaceforcingsWindVy")==0) return SurfaceforcingsWindVyEnum;
+	      else if (strcmp(name,"Matseaice")==0) return MatseaiceEnum;
+	      else if (strcmp(name,"MaterialsPoisson")==0) return MaterialsPoissonEnum;
+	      else if (strcmp(name,"MaterialsYoungModulus")==0) return MaterialsYoungModulusEnum;
+	      else if (strcmp(name,"MaterialsDamage")==0) return MaterialsDamageEnum;
+	      else if (strcmp(name,"MaterialsRidgingExponent")==0) return MaterialsRidgingExponentEnum;
+	      else if (strcmp(name,"MaterialsCohesion")==0) return MaterialsCohesionEnum;
+	      else if (strcmp(name,"MaterialsInternalFrictionCoef")==0) return MaterialsInternalFrictionCoefEnum;
+	      else if (strcmp(name,"MaterialsCompressionCoef")==0) return MaterialsCompressionCoefEnum;
+	      else if (strcmp(name,"MaterialsTractionCoef")==0) return MaterialsTractionCoefEnum;
+	      else if (strcmp(name,"VxStar")==0) return VxStarEnum;
+	      else if (strcmp(name,"VyStar")==0) return VyStarEnum;
 	      else if (strcmp(name,"MaximumNumberOfDefinitions")==0) return MaximumNumberOfDefinitionsEnum;
          else stage=7;
Index: issm/trunk-jpl/src/m/classes/geometry.m
===================================================================
--- issm/trunk-jpl/src/m/classes/geometry.m	(revision 18491)
+++ issm/trunk-jpl/src/m/classes/geometry.m	(revision 18492)
@@ -58,4 +58,8 @@
 		function md = checkconsistency(obj,md,solution,analyses) % {{{
 
+			if (solution==SeaiceSolutionEnum()),
+				return;
+			end
+
 			if (solution==TransientSolutionEnum() & md.transient.isgia) | (solution==GiaSolutionEnum()),
 				md = checkfield(md,'fieldname','geometry.thickness','forcing',1,'NaN',1,'>=',0);
Index: issm/trunk-jpl/src/m/classes/mask.m
===================================================================
--- issm/trunk-jpl/src/m/classes/mask.m	(revision 18491)
+++ issm/trunk-jpl/src/m/classes/mask.m	(revision 18492)
@@ -40,4 +40,7 @@
 		end % }}}
 		function md = checkconsistency(obj,md,solution,analyses) % {{{
+			if (solution==SeaiceSolutionEnum()),
+				return;
+			end
 
 			md = checkfield(md,'fieldname','mask.groundedice_levelset','size',[md.mesh.numberofvertices 1]);
@@ -61,4 +64,8 @@
 			WriteData(fid,'object',obj,'fieldname','ice_levelset','format','DoubleMat','mattype',1);
 
+			if(md.private.solution==SeaiceSolutionEnum()),
+				return;
+			end
+
 			% get mask of vertices of elements with ice
 			isice=md.mask.ice_levelset<=0.;
